#
# spec file for package git-annex
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           git-annex
Version:        6.20170519
Release:        1.5
Summary:        Manage files with git, without checking their contents into git
License:        GPL-3.0+ AND AGPL-3.0+ AND BSD-2-Clause AND MIT AND GPL-2.0
Group:          Development/Tools/Version Control
Url:            https://hackage.haskell.org/package/%{name}
Source0:        https://github.com/peti/git-annex/archive/%{version}.tar.gz#/%{name}-%{version}.tar.gz
BuildRequires:  bash-completion
BuildRequires:  curl
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-DAV-devel
BuildRequires:  ghc-IfElse-devel
BuildRequires:  ghc-QuickCheck-devel
BuildRequires:  ghc-SafeSemaphore-devel
BuildRequires:  ghc-aeson-devel
BuildRequires:  ghc-async-devel
BuildRequires:  ghc-aws-devel
BuildRequires:  ghc-blaze-builder-devel
BuildRequires:  ghc-bloomfilter-devel
BuildRequires:  ghc-byteable-devel
BuildRequires:  ghc-bytestring-devel
BuildRequires:  ghc-case-insensitive-devel
BuildRequires:  ghc-clientsession-devel
BuildRequires:  ghc-concurrent-output-devel
BuildRequires:  ghc-conduit-devel
BuildRequires:  ghc-conduit-extra-devel
BuildRequires:  ghc-containers-devel
BuildRequires:  ghc-crypto-api-devel
BuildRequires:  ghc-cryptonite-devel
BuildRequires:  ghc-data-default-devel
BuildRequires:  ghc-dbus-devel
BuildRequires:  ghc-directory-devel
BuildRequires:  ghc-disk-free-space-devel
BuildRequires:  ghc-dlist-devel
BuildRequires:  ghc-dns-devel
BuildRequires:  ghc-edit-distance-devel
BuildRequires:  ghc-esqueleto-devel
BuildRequires:  ghc-exceptions-devel
BuildRequires:  ghc-fdo-notify-devel
BuildRequires:  ghc-feed-devel
BuildRequires:  ghc-filepath-devel
BuildRequires:  ghc-free-devel
BuildRequires:  ghc-hinotify-devel
BuildRequires:  ghc-hslogger-devel
BuildRequires:  ghc-http-client-devel
BuildRequires:  ghc-http-conduit-devel
BuildRequires:  ghc-http-types-devel
BuildRequires:  ghc-magic-devel
BuildRequires:  ghc-memory-devel
BuildRequires:  ghc-monad-control-devel
BuildRequires:  ghc-monad-logger-devel
BuildRequires:  ghc-mountpoints-devel
BuildRequires:  ghc-mtl-devel
BuildRequires:  ghc-network-devel
BuildRequires:  ghc-network-info-devel
BuildRequires:  ghc-network-multicast-devel
BuildRequires:  ghc-network-uri-devel
BuildRequires:  ghc-old-locale-devel
BuildRequires:  ghc-optparse-applicative-devel
BuildRequires:  ghc-path-pieces-devel
BuildRequires:  ghc-persistent-devel
BuildRequires:  ghc-persistent-sqlite-devel
BuildRequires:  ghc-persistent-template-devel
BuildRequires:  ghc-process-devel
BuildRequires:  ghc-random-devel
BuildRequires:  ghc-regex-tdfa-devel
BuildRequires:  ghc-resourcet-devel
BuildRequires:  ghc-rpm-macros
BuildRequires:  ghc-sandi-devel
BuildRequires:  ghc-securemem-devel
BuildRequires:  ghc-shakespeare-devel
BuildRequires:  ghc-socks-devel
BuildRequires:  ghc-split-devel
BuildRequires:  ghc-stm-chans-devel
BuildRequires:  ghc-stm-devel
BuildRequires:  ghc-tasty-devel
BuildRequires:  ghc-tasty-hunit-devel
BuildRequires:  ghc-tasty-quickcheck-devel
BuildRequires:  ghc-tasty-rerun-devel
BuildRequires:  ghc-template-haskell-devel
BuildRequires:  ghc-text-devel
BuildRequires:  ghc-time-devel
BuildRequires:  ghc-torrent-devel
BuildRequires:  ghc-transformers-devel
BuildRequires:  ghc-unix-compat-devel
BuildRequires:  ghc-unix-devel
BuildRequires:  ghc-unordered-containers-devel
BuildRequires:  ghc-utf8-string-devel
BuildRequires:  ghc-uuid-devel
BuildRequires:  ghc-wai-devel
BuildRequires:  ghc-wai-extra-devel
BuildRequires:  ghc-warp-devel
BuildRequires:  ghc-warp-tls-devel
BuildRequires:  ghc-yesod-core-devel
BuildRequires:  ghc-yesod-default-devel
BuildRequires:  ghc-yesod-devel
BuildRequires:  ghc-yesod-form-devel
BuildRequires:  ghc-yesod-static-devel
# Manually added dependencies which the Cabal file does not declare
BuildRequires:  git-core
BuildRequires:  rsync
Requires:       git-core
Requires(post): desktop-file-utils
Requires(post): hicolor-icon-theme
Requires(postun): desktop-file-utils
Requires(postun): hicolor-icon-theme
Recommends:     curl
Recommends:     gpg2
Recommends:     lsof
Recommends:     rsync
Recommends:     ssh
Suggests:       %{name}-bash-completion
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Git-annex allows managing files with git, without checking the file contents
into git. While that may seem paradoxical, it is useful when dealing with files
larger than git can currently easily handle, whether due to limitations in
memory, time, or disk space.

It can store large files in many places, from local hard drives, to a large
number of cloud storage services, including S3, WebDAV, and rsync, with a dozen
cloud storage providers usable via plugins. Files can be stored encrypted with
gpg, so that the cloud storage provider cannot see your data.
git-annex keeps track of where each file is stored, so it knows how many copies
are available, and has many facilities to ensure your data is preserved.

git-annex can also be used to keep a folder in sync between computers, noticing
when files are changed, and automatically committing them to git and
transferring them to other computers. The git-annex webapp makes it easy to set
up and use git-annex this way.

%package bash-completion
Summary:        Bash completion for git-annex
Group:          System/Shells
Requires:       %{name} = %{version}
Requires:       bash-completion
Supplements:    packageand(%{name}:bash-completion)

%description bash-completion
Optional dependency offering bash completion for git-annex

%prep
%setup -q

%build
%ghc_bin_build

%install
%ghc_bin_install
make DESTDIR=%{buildroot} BUILDER=./Setup install-misc install-mans

%check
make %{?_smp_mflags} DESTDIR=%{buildroot} BUILDER=./Setup test

%post
%desktop_database_post
%icon_theme_cache_post

%postun
%desktop_database_postun
%icon_theme_cache_postun

%files
%defattr(-,root,root,-)
%doc COPYRIGHT README
%{_bindir}/%{name}
%{_bindir}/%{name}-shell
%{_bindir}/git-remote-tor-annex
%dir %{_datadir}/icons/hicolor
%dir %{_datadir}/icons/hicolor/16x16
%dir %{_datadir}/icons/hicolor/16x16/apps
%dir %{_datadir}/icons/hicolor/scalable
%dir %{_datadir}/icons/hicolor/scalable/apps
%{_sysconfdir}/xdg/autostart/git-annex.desktop
%{_mandir}/man1/git-annex*.1%{ext_man}
%{_mandir}/man1/git-remote-tor-annex.1%{ext_man}
%{_datadir}/applications/git-annex.desktop
%{_datadir}/icons/hicolor/16x16/apps/git-annex.png
%{_datadir}/icons/hicolor/scalable/apps/git-annex.svg

%files bash-completion
%defattr(-,root,root)
%{_datadir}/bash-completion/completions/git-annex

%changelog
* Mon May 22 2017 psimons@suse.com
- Update to version 6.20170519 with cabal2obs.
* Tue May 16 2017 psimons@suse.com
- Update to version 6.20170510 with cabal2obs.
* Wed Mar 22 2017 psimons@suse.com
- Update to version 6.20170321 with cabal2obs.
  * Bugfix: Passing a command a filename that does not exist sometimes did not display an error, when a path to a directory was also passed.
  * status: Propigate nonzero exit code from git status.
  * Linux standalone builds put the bundled ssh last in PATH, so any system ssh will be preferred over it.
  * assistant: Add 1/200th second delay between checking each file in the full transfer scan, to avoid using too much CPU.
  * get -J: Improve distribution of jobs amoung remotes when there are more jobs than remotes.
  * fsck -q: When a file has bad content, include the name of the file in the warning message.
  * Windows: Improve handling of shebang in external special remote program, searching for the program in the PATH.
  * Drop support for building with old versions of dns, http-conduit, directory, feed, and http-types.
  * Windows: Fix bug in shell script shebang lookup code that caused a "delayed read on closed handle" error.
  * git-annex-shell: Fix bug when used with a recently cloned repository, where "merging" messages were included in the output of configlist (and perhaps other commands) and caused a "Failed to get annex.uuid configuration" error.
  * Support GIT_SSH and GIT_SSH_COMMAND, which are handled close the same as they are by git. However, unlike git, git-annex sometimes needs to pass the -n parameter when using these.
  * sync --content-of=path (-C path) added for when you want to sync only some files' contents, not the whole working tree.
* Thu Mar  2 2017 psimons@suse.com
- Update to version 6.20170301.1 with cabal2obs.
* Mon Feb 20 2017 psimons@suse.com
- Update to version 6.20170214 with cabal2obs.
* Wed Jan  4 2017 psimons@suse.com
- Update to version 6.20170101 with cabal2obs.
* Fri Dec 16 2016 psimons@suse.com
- Update to version 6.20161210 with cabal2obs.
* Sun Nov 20 2016 psimons@suse.com
- Update to version 6.20161118 with cabal2obs.
* Mon Nov 14 2016 psimons@suse.com
- Update to version 6.20161111 with cabal2obs.
* Tue Nov  1 2016 psimons@suse.com
- Update to version 6.20161031 with cabal2obs.
* Sun Oct 30 2016 psimons@suse.com
- Update to version 6.20161027 with cabal2obs.
* Mon Oct 17 2016 psimons@suse.com
- Update to version 6.20161012 with cabal2obs.
* Mon Sep 26 2016 psimons@suse.com
- Update to version 6.20160923 with cabal2obs.
* Wed Sep 21 2016 psimons@suse.com
- Update to version 6.20160907 with cabal2obs.
* Sun Jul 10 2016 psimons@suse.com
- Update to version 6.20160511 revision 0 with cabal2obs.
* Fri Jun 17 2016 psimons@suse.com
- Declare the fact that the git-annex bash-completion sub-package
  supplements normal bash-completions, i.e. it's a recommended
  package. Suggested by @dimstar in his OBS review.
* Tue Jun 14 2016 mimi.vx@gmail.com
- Declare build requirement on 'bash-completion' to fix the build in
  Tumbleweed.
* Thu May 12 2016 mimi.vx@gmail.com
- update to 6.20160511
  * Fix bug that sometimes prevented git-annex smudge --clean from consuming
    all its input, which resulted in git add bypassing git-annex.
  * Fix build with directory-1.2.6.2.
  * Improve behavior when a just added http remote is not available
    during uuid probe. Do not mark it as annex-ignore, so it will be tried
    again later.
  * Added DIRHASH-LOWER to external special remote protocol.
  * git-annex.cabal: Add Setup-Depends.
  * map: Hide dead repositories that are not connected to the graph.
  * map: Changed colors; red is used for untrusted repositories and grey
    for dead.
  * version: Display OS version and architecture too.
  * Propigate GIT_DIR and GIT_WORK_TREE environment to external special
    remotes.
  * Added annex.gnupg-decrypt-options and
    remote.<name>.annex-gnupg-decrypt-options, which are passed to gpg
    when it's decrypting data.
  * fsck: When a key is not previously known in the location log,
    record something so that reinject --known will work.
  * In the unusual configuration where annex.crippledfilesystem=true but
    core.symlinks=true, store object contents in mixed case hash
    directories so that symlinks will point to them.
  * Added new encryption=sharedpubkey mode for special remotes.
    This is useful for makking a special remote that anyone with a clone
    of the repo and your public keys can upload files to, but only you can
    decrypt the files stored in it.
* Sat Apr 30 2016 mimi.vx@gmail.com
- update to 6.20160419
  * Fix bug that prevented resuming of uploads to encrypted special remotes
    that used chunking.
  * That bug could also expose the names of keys to such remotes when
    attempting to resume an upload, so it is a minor security issue.
  * Fix duplicate progress meter display when downloading from a git remote
    over http with -J.
  * reinject: When src file's content cannot be verified, leave it alone,
    instead of deleting it.
  * reinject: Added new mode which can reinject known files into the annex.
    For example: git-annex reinject --known /mnt/backup/*
  * calckey: New plumbing command, calculates the key that would be used
    to refer to a file.
  * Fix bug that prevented annex.sshcaching=false configuration from taking
    effect when on a crippled filesystem. Thanks, divergentdave.
  * git 2.9.0 is going to prevent git merge from merging in unrelated
    branches. Since the webapp's pairing etc features often combine
    together repositories with unrelated histories, work around
    this behavior change when the assistant merges, by passing
  - -allow-unrelated-histories. Note though that this is not done
    for git annex sync's merges, so it will follow git's default or
    configured behavior.
  * When git-annex is used with a git version older than 2.2.0, disable
    support for adjusted branches, since GIT_COMMON_DIR is needed to update
    them and was first added in that version of git.
  * Avoid setting LOCPATH in linux standalone builds that are built with
    a ghc that has been fixed to not hang when it cannot find locale files.
  * Isolate test suite from global git config settings.
* Thu Apr 28 2016 psimons@suse.com
- Add "ghc-magic" dependency to enable support for libmagic-based
  guessing of MIME types.
* Thu Apr 28 2016 psimons@suse.com
- Add "ghc-mountpoints" dependency to fix support for the Assistant.
* Tue Apr 26 2016 psimons@suse.com
- Improve accuracy of the license header to include AGPL-licensed
  parts of the package.
* Tue Apr 19 2016 mimi.vx@gmail.com
- update to 6.20160418
  * smudge: Print a warning when annex.thin is set, as git's smudge
    interface does not allow honoring that configuration.
  * webapp: When $HOME is a git repository, and has been initialized for
    use by git-annex, opening the webapp went ahead and ran the assistant
    there, annexing all files. Since this is almost certianly not
    desirable, especially when the user is just opening the webapp from
    a dekstop menu which happens to run it in $HOME, the webapp will now not
    treat such a $HOME git repository as a git-annex repository.
  * webapp: Update url to add gitlab.com ssh key.
  * Fix bug in v6 mode that prevented treating unlocked executable files
    as annexed. If you have such files, run git annex init --version=6
    to update the cache after upgrading to this version of git-annex.
  * Preserve execute bits of unlocked files in v6 mode.
  * fsck: Warn when core.sharedRepository is set and an annex object file's
    write bit is not set and cannot be set due to the file being owned
    by a different user.
  * Fix hang when dropping content needs to lock the content on a
    ssh remote, which occurred when the remote has git-annex version
    5.20151019 or newer.
* Wed Apr 13 2016 mimi.vx@gmail.com
- update to 6.20160412
  * adjust --unlock: Enters an adjusted branch in which all annexed files
    are unlocked. The v6 equivilant of direct mode, but much cleaner!
  * Upgrading a direct mode repository to v6 has changed to enter
    an adjusted unlocked branch. This makes the direct mode to v6 upgrade
    able to be performed in one clone of a repository without affecting
    other clones, which can continue using v5 and direct mode.
  * init --version=6: Automatically enter the adjusted unlocked branch
    when filesystem doesn't support symlinks.
  * ddar remote: fix ssh calls
  * log: Display time with time zone.
  * log --raw-date: Use to display seconds from unix epoch.
  * v6: Close pointer file handles more quickly, to avoid problems on Windows.
  * sync: Show output of git commit.
  * Fix bug in annex.largefiles mimetype= matching when git-annex
    is run in a subdirectory of the repository.
* Mon Mar 21 2016 mimi.vx@gmail.com
- update to 6.20160318
  * metadata: Added -r to remove all current values of a field.
  * Fix data loss that can occur when annex.pidlock is set in a repository.
  * Fix bug preventing moving files to/from a repository with annex.pidlock set.
  * Fix shared lock file FD leak.
  * Fix metadata hook behavior when multiple files are added at once.
  * Added dependencies on haskell mountpoints and disk-free-space
    libraries, removing FFI code from git-annex.
  * dropkey: Add --batch and --json.
  * Always try to thaw content, even when annex.crippledfilesystem is set.
  * Correct git-annex info to include unlocked files in v6 repository.
  * Sped up git-annex add in direct mode and v6 by using
    git hash-object --stdin-paths.
  * Sped up git-annex merge by using git hash-object --stdin-paths.
* Mon Mar  7 2016 mimi.vx@gmail.com
- update to 6.20160229
  * Update perlmagick build dependency.
  * Fix memory leak in last release, which affected commands like
    git-annex status when a large non-annexed file is present in the work
    tree.
  * fsck: When the only copy of a file is in a dead repository, mention
    the repository.
  * info: Mention when run in a dead repository.
  * Linux and OSX standalone builds put the bundled gpg last in PATH,
    so any system gpg will be preferred over it.
  * Avoid crashing when built with MagicMime support, but when the magic
    database cannot be loaded.
  * Include magic database in the linux and OSX standalone builds.
  * Fix memory leak when hashing files, which triggered during fsck
    when an external hash program was not used.
    (This leak was introduced in version 6.20160114.)
  * Support --metadata field<number, --metadata field>number etc
    to match ranges of numeric values.
  * Similarly, support preferred content expressions like
    metadata=field<number and metadata=field>number
  * The pre-commit-annex hook script that automatically extracts
    metadata has been updated to also use exiftool.
* Sun Feb 28 2016 mimi.vx@gmail.com
- update to 6.20160211
  * annex.addsmallfiles: New option controlling what is done when
    adding files not matching annex.largefiles.
  * Fix reversion in lookupkey, contentlocation, and examinekey which
    caused them to sometimes output side messages.
  * webapp: Fix deletion of current repository directory.
  * Added "nothing" to preferred content expression syntax.
  * annex.largefiles can be configured in .gitattributes too;
    this is particulary useful for v6 repositories, since the
    .gitattributes configuration will apply in all clones of the
    repository.
  * Limit annex.largefiles parsing to the subset of preferred content
    expressions that make sense in its context. So, not "standard"
    or "lackingcopies", etc.
  * annex.largefiles: Add support for mimetype=text/* etc, when git-annex
    is linked with libmagic.
  * matchexpression: Added --largefiles option to parse an annex.largefiles
    expression.
  * Brought back the dbus and xmpp build flags, so build from source can be
    done without C libraries that may be hard to install.
  * init: Fix bugs in submodule .git symlink fixup, that occurred when
    initializing in a subdirectory of a submodule and a submodule of a
    submodule.
  * WebDAV: Set depth 1 in PROPFIND request, for better compatibility with
    some servers. Thanks, wzhd.
  * WebDAV: Remove a bogus trailing slash from the end of the url to the
    temporary store location for a key. Thanks, wzhd.
  * S3: Allow configuring with requeststyle=path to use path-style bucket
    access instead of the default DNS-style access.
  * Fix nasty reversion in the last release that broke sync --content's
    handling of many preferred content expressions.
  * whereis --json: Urls are now listed inside the remote that claims them,
    rather than all together at the end.
  * info, add, whereis, find: Support --batch mode.
  * Force output to be line-buffered, even when it's not connected to the
    terminal. This is particuarly important for commands with --batch
    output, which was not always being flushed at an appropriate time.
  * add, import: Support --json output.
  * addurl --json: Include field for added key (unless the file was
    added directly to git due to annex.largefiles configuration.)
    (Also done by add --json and import --json)
  * registerurl: Check if a remote claims the url, same as addurl does.
  * Bug fix: Git config settings passed to git-annex -c did not always take
    effect.
  * assistant: Use udisks2 dbus events to detect when disks are mounted,
    instead of relying on gnome/kde stuff that is not stable.
  * Fix build with QuickCheck 2.8.2
  * matchexpression: New plumbing command to check if a preferred content
    expression matches some data.
  * Removed the webapp-secure build flag, rolling it into the webapp build
    flag.
  * Removed the quvi, tahoe, feed, and tfds build flags, adding
    aeson feed and regex-tdfa to the core dependencies.
  * Roll the dns build flag into the assistant build flag.
* Tue Feb 23 2016 psimons@suse.com
- Initial version of git-annex-6.20160114.
